/**
 * Created by JSmith on 3/7/2016.
 */

angular.module('components.assignmentDisplay', [])
    .controller('AssignmentDisplayController', ['$scope', "$timeout", "$mdDialog", "CaseDisplayBPMServices", function ($scope, $timeout, $mdDialog, CaseDisplayBPMServices) {
        //console.log("*****************AssignmentDisplayDirective Controller");
            //console.log("*****************AssignmentDisplayDirective Controller workItemId ", $scope.workItemId);
        //console.log("*****************AssignmentDisplayDirective Controller state ", $scope.itemState);


        CaseDisplayBPMServices.getOfferSet($scope.workItemId).then(
            function (result) {
                //console.log("Entity: " + result);
                $scope.entityId = result.entityId[0].guid;
                CaseDisplayBPMServices.getResourcesForEntity($scope.entityId).then(
                    function (resultOfferset) {
                        //console.log("Offerset: " + JSON.stringify(resultOfferset));
                        $scope.offerset = resultOfferset.resource;
                        $mdDialog.show({
                                controller: DialogController,
                                templateUrl: 'components/assignment-display/assignment-dialog.html',
                                parent: angular.element(document.body),
                                clickOutsideToClose:true,
                                fullscreen: false,
                                locals:{offerset: $scope.offerset},
                            })
                            .then(function(answer) {
                                if (answer != 'cancel' && answer.guid != null) {
                                    // reassign task
                                    if ($scope.itemState === 'OFFERED') {
                                        CaseDisplayBPMServices.allocate($scope.workItemId, answer.guid).then(
                                            function (resultOfferset) {
                                                //console.log("Allocated task to " + answer.name);

                                                alert("Task has been allocated to " + answer.name);
                                            });
                                    } else {
                                        CaseDisplayBPMServices.reallocateTask($scope.workItemId, answer.guid).then(
                                            function (resultOfferset) {
                                                //console.log("Reallocated task to " + answer.name);

                                                alert("Task has been re-assigned to " + answer.name);
                                            });
                                    }
                                }
                            }, function() {
                                //alert("Cancelled");

                            });

                    });

            });





}]);
function DialogController($scope, $mdDialog, offerset) {
    $scope.offerset = offerset
    $scope.hide = function() {
        $mdDialog.hide();
    };
    $scope.cancel = function() {
        $mdDialog.cancel();
    };
    $scope.answer = function(answer) {
        $mdDialog.hide(answer);
    };
}

