/**
 * Created by Jez on 6/9/2016.
 */

angular.module('components.businessServiceMenu', [])
    .controller('BusinessServiceMenuController', ['$scope', '$rootScope', "$timeout", "$location", "BPMBusinessActionsService", "CaseDisplayBPMServices", function ($scope, $rootScope, $timeout, $location, BPMBusinessActionsService, CaseDisplayBPMServices) {
		//console.log("*****************BusinessServiceMenu Controller");
		//console.log("*****************BusinessServiceMenu Controller category: " + $scope.categories);

		$scope.ready = false;
		$scope.formdiv = 'businessServiceFormDiv';

		// these are required for the bpm-business-actions component
		$scope.setMainContent = function (content) {
		}

		$scope.toggleExpandFn = function (expandActions) {
		}

		$scope.startBizAction = function(action) {

			//TODO: Make spinner generic
			// set up spinner
			var opts = {
				lines: 13 // The number of lines to draw
				, length: 28 // The length of each line
				, width: 12 // The line thickness
				, radius: 42 // The radius of the inner circle
				, scale: 0.75 // Scales overall size of the spinner
				, corners: 0.6 // Corner roundness (0..1)
				, color: '#000' // #rgb or #rrggbb or array of colors
				, opacity: 0.25 // Opacity of the lines
				, rotate: 0 // The rotation offset
				, direction: 1 // 1: clockwise, -1: counterclockwise
				, speed: 1.2 // Rounds per second
				, trail: 86 // Afterglow percentage
				, fps: 20 // Frames per second when using setTimeout() as a fallback for CSS
				, zIndex: 2e9 // The z-index (defaults to 2000000000)
				, className: 'spinner' // The CSS class to assign to the spinner
				, top: '50%' // Top position relative to parent
				, left: '50%' // Left position relative to parent
				, shadow: false // Whether to render a shadow
				, hwaccel: false // Whether to use hardware acceleration
				, position: 'absolute' // Element positioning
			}
			var target = document.getElementById('loadingSpinner');
			var spinner = new Spinner(opts);
			spinner.spin(target);



			var businessActionTemplate = {};
			businessActionTemplate.itemData = {};
			businessActionTemplate.itemData.moduleName =  action.moduleName;
			businessActionTemplate.itemData.processName = action.processName;
			businessActionTemplate.itemData.version = action.version;
			// switch calling app to show the correct pane
			$scope.showAction({data:"no",page:"pageBusinessService"});
			businessActionTemplate.formDiv = $scope.formDiv;

			if (BPMBusinessActionsService){
				BPMBusinessActionsService.startBizAction(businessActionTemplate, {
					onSuccess: function(result){
						// {\"items\":[{\"$param\":\"caseRef\",\"$value\":[\"BDS-1-Service.Cases.Customer-4165-0\"],\"type\":\"String\",\"mode\":\"OUT\"}]}"}}]}"
						// if we got a parameter back - check if it is caseRef. If it is navigate to the case page
						if (result.pageData != undefined) {
                            if (result.pageData[0] != null && result.pageData[0].payload != null && result.pageData[0].payload.serializedPayload != null) {
                                var resultPayload = result.pageData[0].payload.serializedPayload;
                                resultParams = JSON.parse(resultPayload);
                                var caseRef;
                                angular.forEach(resultParams.items, function (item) {
                                    if (item.$param == 'caseRef') {
                                        // found the caseRef
                                        caseRef = item.$value[0];
                                    }
                                })
                                if (caseRef != null) {
                                    // navigate to case
                                    ////console.log("Setting caseref to: " + $scope.marking.case_ref);
                                    $location.path("/pageCaseDisplay/" + caseRef);
                                    $scope.$apply();
                                } else {
                                    $scope.showAction({data: "default", page: "default"});
                                    $scope.$apply();
                                }
                            } else {
                                $scope.showAction({data: "default", page: "default"});
                                $scope.$apply();
                            }
                        }
					},
					onFailure: function(exception){
						spinner.stop();
					},
					onEvent: function(eventName, bizActionHandler){
						if (eventName == "bs.START") {
						} else if (eventName == "bs.COMPLETE") {
						} else if (eventName == "bs.CANCEL") {
                            $location.path("/pageHome");
                            $scope.$apply();
						} else if (eventName == "bs.FORM_LOAD") {
							spinner.stop();
						}
					}
				});
			}
		}

		// get business service categories (top level)

		$scope.getBusinessServices = function () {
			//console.log('*** Running getBusinessServices');
			$scope.businessActions = [];
			for (y=0; y<$scope.categories.length;y++) {
				var thisCat = $scope.categories[y];
				CaseDisplayBPMServices.queryBusinessServicesByCategory(thisCat).then(
					function (result) {
						for (x=0;x<result.businessServiceTemplate.length; x++) {
							result.businessServiceTemplate[x].category = thisCat;
							$scope.businessActions.push(result.businessServiceTemplate[x]);
						}
						//console.log("BS list: " + JSON.stringify($scope.businessActions));
						$scope.ready = true;
					},
					function (error) {
						console.error("ERR_CASE_BSMENU_CTLR_GET_BS: " + error);
					}
				);
            }

            // switched from using component service it no longer returns BS with params in 4.2
			/*BPMBusinessActionsService.fetchTopCategories($scope.businessActionsServiceModel, {
				onSuccess: function (result) {
					console.log("Orig result" + JSON.stringify(result));
					$scope.ready = true;
				},
				onFailure: function () {
					//console.log();
				}
			})*/
		}

		$scope.getBusinessServices();
	}

			]);
