/**
 * Created by NamOs on 08/09/15.
 */

angular.module('components.caseActionList', ['components.payloadService'])
    .controller('CaseActionListController', ['$scope', 'CaseDisplayBPMServices', 'BPMBusinessActionsService', 'PayloadService', function ($scope, CaseDisplayBPMServices, BPMBusinessActionsService, PayloadService) {
        //console.log("*** Case Action List Controller");

        $scope.listCaseAction = function (caseRef) {
            $scope.caseRef = caseRef;

            //TODO replace the GlobalRef by a passed parameter
            CaseDisplayBPMServices.listCaseAction(caseRef).then(
                function (result) {

                    //TODO can create a service function to get the inner payload => carefull it is for one element out only
                    var caseActionTemplates = result.caseCategory;


                    if ($scope.limitWithAdhocTasks === 'true') {
                        // This directive parameter enables limiting actions based on matching adhoc tasks
                        // If you have an adhoc task with the same name as an action, and the enabled property is false:
                        //  - This option will remove that matching action from the available action list
                        //  - This is a workaround until actions allow you to set rule based availability

                        CaseDisplayBPMServices.listAdhocActivitiesByGlobalRef($scope.caseRef).then(
                            function (result) {


                                //If we have a matching adhoc task - AND the task is NOT enabled, remove it from the action list


                                $scope.adHocTasks = result.activity;

                                if ($scope.adHocTasks != undefined) {

                                    for (i = 0; i < $scope.adHocTasks.length; i++) {
                                        var task = $scope.adHocTasks[i];
                                        var taskname = task.name;
                                        if (task.enabled != true) {
                                            // now go through the actions, any that are the same as this disabled adhoc task

                                            for (t = 0; t < caseActionTemplates.length; t++) {
                                                // get the name
                                                var pname = caseActionTemplates[t].caseActionTemplate[0].processName;

                                                // if it is the same name - remove it!
                                                if (pname.toUpperCase() === taskname.toUpperCase()) {
                                                    caseActionTemplates.splice(t, 1);
                                                }

                                            }
                                        }


                                    }
                                }
                                $scope.caseActionTemplates = caseActionTemplates;


                            },
                            function (error) {
                                window.cap.LOGGER.error("ERR_CUST_CLIENT_CTLR_GET_WORK_LIST_ITEMS: " + error);
                            }
                        );
                    } else {
                        $scope.caseActionTemplates = caseActionTemplates;
                    }

                },
                function (error) {
                    window.cap.LOGGER.error("ERR_CUST_CLIENT_CTLR_GET_WORK_LIST_ITEMS: " + error);
                }
            );
        }

        //run the bizAction thanks to a passed method in the directive
        $scope.doAction = function (caseTemplate) {

            var businessActionTemplate = {};
            businessActionTemplate.itemData = caseTemplate;
            businessActionTemplate.payload = PayloadService.createCaseActionPayload($scope.caseRef, caseTemplate.caseRefParamName);
            businessActionTemplate.formDiv = "workItem";
		
			$scope.actionMethod({actionTemplate: businessActionTemplate});

        }
		
		var vm = this;
		vm.actionBox = true;		
		vm.toggle = function (name) {
			vm[name] = !vm[name];
		};	

    }]);