/**
 * Created by JeremyS on 04/01/16.
 */
angular.module('components.caseAuditDisplay.directive', ['components.caseAuditDisplay'])
    .directive('caseAuditDisplayDirective', caseAuditDisplayDirective);


function caseAuditDisplayDirective() {
    return {
        //TODO review restrict in all directives, I setup AEC to get all but should be minimized
        restrict: 'AEC',
        controller: 'CaseAuditDisplayController',
		controllerAs: 'caseAuditDisplay',
        scope : {
            caseReference : '=',
			header: '@',
			headerClass: '@',
			id: '@',
            stateFilter: '='
        },
        link: function($scope, element, attrs) {
			$scope.getContentUrl = function () {
				////console.log ("Case Audit Template path : " + attrs.templatePath);
                if (typeof attrs.templatePath  == 'undefined') {
                    ////console.log ("Template path undefined => returning default");
                    return 'case-audit-display.html';
                } else {
                    ////console.log ("Template path is defined, returning : " + attrs.templatePath);
                    return attrs.templatePath;
                }
            }
			$scope.contentUrl = $scope.getContentUrl();
            $scope.$watch("caseReference", function(newVal, oldVal){
                if (newVal ) {
                    $scope.listCaseAudit(newVal);
                }
            });
        },
		template: '<div ng-include="contentUrl"></div>'
    };
}
