/**
 * Created by JSmith on 3/15/2016.
 */

angular.module('components.caseClassDisplay', ['components.bpmCaseDisplay', 'components.caseClassDisplay.directive', 'camelCaseToHuman'])
    .controller('CaseClassDisplayController', ['$scope', "BPMWorklistService", "BPMBusinessActionsService", "BPMLoginService", "CaseInformationService", "CaseDisplayBPMServices", "$mdDialog", "$timeout", "$location", "PayloadService", function ($scope, BPMWorklistService, BPMBusinessActionsService, BPMLoginService, CaseInformationService, CaseDisplayBPMServices, $mdDialog, $timeout, $root, PayloadService) {
        //console.log("*****************CaseClassDisplayDirective Controller");
	var vm = this;
	$scope.editMode = false;
	vm.id = $scope.id;
	vm.headerBox = true;
	vm.docsSearchBox = true;
	
	vm.toggle = function (name) {
		vm[name] = !vm[name];
    }
	
	//$root.caseClassTreeQuery = "hello";
	
	$scope.isDate = function(date) {
		var formats = [
			moment.ISO_8601,
			"MM/DD/YYYY  :)  HH*mm*ss"
		];
		return moment(date, formats, true).isValid();
	}

	// check for edit action
	CaseDisplayBPMServices.listCaseAction($scope.caseReference).then(
		function (result) {
			var caseActionTemplates = result.caseCategory;
			for (x=0;x<caseActionTemplates.length;x++) {
				var template = caseActionTemplates[x].caseActionTemplate[0];
				if (template.processName == 'Update' + $scope.className) {
					$scope.classEditAction = template;
				}
			}
		}
	);

		vm.runEditAction = function () {
			var businessActionTemplate = {};
			businessActionTemplate.itemData = $scope.classEditAction;
			businessActionTemplate.formDiv = $scope.headerClass + '_div';
			businessActionTemplate.payload = PayloadService.createCaseActionPayload($scope.caseReference, $scope.classEditAction.caseRefParamName);

			CaseDisplayBPMServices.logCaseAudit($scope.caseReference, $scope.userName, $scope.userGuid, businessActionTemplate.itemData.processName, $scope.state, 'CMF_CASE_ACTION_STARTED', 'Case action started');

			BPMBusinessActionsService.startBizAction(businessActionTemplate, {
				onSuccess: function (Payload) {
					$timeout(function() {
					});
				},
				onFailure: function () {
					$timeout(function() {
						//vm.bizActionFormTabs.splice(vm.bizActionFormTabs.indexOf(businessActionTemplate), 1);
						//vm.$apply("");
					});
				},
				onEvent: function(eventName, bizActionHandler){
					if (eventName == 'bs.FORM_LOAD') {
						$scope.editMode = true;
						$scope.$apply();
					}
					if (eventName == 'bs.COMPLETE' || eventName == 'bs.CANCEL') {
						$scope.editMode = false;
						//vm.bizActionFormTabs.splice(vm.bizActionFormTabs.indexOf(businessActionTemplate), 1);
						if (eventName == 'bs.COMPLETE') {
							CaseDisplayBPMServices.logCaseAudit($scope.caseReference, $scope.userName, $scope.userGuid, businessActionTemplate.itemData.processName, $scope.state, 'CMF_CASE_ACTION_COMPLETED', 'Case action completed');
							$scope.$apply();
							// refresh?
							$scope.refresh();

						} else {
							//vm.$apply("");
						}

					}
				}
			});
		}



}])