angular.module('components.caseDocumentUpload', [])
    .controller('caseDocumentUploadController', ['$scope', 'fileUpload', '$http', 'CaseDocumentService', function($scope, fileUpload, $http, CaseDocumentService){
	
        uploadFileToUrlExt = function(file, uploadUrl, refresh){
            var fd = new FormData();
            fd.append('file', file);
            fd.enctype = "multipart/form-data";

            $http.post(uploadUrl, fd, {
                    transformRequest: angular.identity,
                    headers: {'Content-Type': undefined}
                })

                .then(function(response){
                    CaseDocumentService.DocumentUploadSuccess(response,file.name);
                    if (refresh != null) {
                        refresh();
                    }
                })

                .catch(function(){
                    CaseDocumentService.DocumentUploadFailure(file.name);
                });
        }

    $scope.uploadFile = function(caseRef){
        var file = $scope.myFile;
        var uploadUrl = "/bpm/document/upload?caseReference=" + encodeURIComponent($scope.caseRef);;
        uploadFileToUrlExt(file, uploadUrl, $scope.$parent.callService);
    };


    
}]);
