/**
 * Created by JSmith on 03/18/16.
 */

angular.module('components.caseMilestone', [])
    .controller('CaseMilestoneController', ['$scope', "$mdDialog", function ($scope, $mdDialog) {
        //console.log("*** Case Milestone Controller");
		
		var vm = this;
		vm.msBox = true;
		
		vm.toggle = function (name) {
			vm[name] = !vm[name];
		}	

		
		$scope.setCaseInfo = function(caseinfo) {
			vm.caseinfo = caseinfo;
			vm.milestoneTrailer = {};
			vm.milestoneTrailer.milestone = [];
			var found = false;
			for (var i = 0; i < caseinfo.states.length; i++) {
				var ms = {};
				ms.name = caseinfo.states[i];
				if (caseinfo.states[i] == vm.caseinfo.state) {
					ms.status = "current";
					found = true;
				} else  {
					ms.status = found ? "todo" : "done";
				}
				vm.milestoneTrailer.milestone.push(ms);
			}
		}

		$scope.showAudit = function(state) {

			$mdDialog.show({
				controller: MilestoneAuditDialogController,
				templateUrl: 'components/case-milestone/templates/case-milestone-audit-dialog.html',
				parent: angular.element(document.body),
				//parent: angular.element(document.getElementById("md-theme-div")),
				clickOutsideToClose: true,
				fullscreen: false,
				locals: {caseRef: $scope.caseinfo.caseRef,stateFilter: state},
			}).then(function () {

			});
		}
    }]);


function MilestoneAuditDialogController($scope, $mdDialog, caseRef, stateFilter) {
	$scope.caseRef = caseRef;
	$scope.stateFilter = stateFilter;
	$scope.hide = function() {
		$mdDialog.hide();
	};
	$scope.cancel = function() {
		$mdDialog.hide();
	};
}
