/**
 * Created by JeremyS on 3/1/17.
 */
angular.module('components.casePendingList.directive', ['components.casePendingList'])
    .directive('casePendingListDirective', casePendingListDirective);


function casePendingListDirective() {
    return {
        //TODO review restrict in all directives, I setup AEC to get all but should be minimized
        restrict: 'AEC',
        controller: 'CasePendingListController',
		controllerAs: 'casePendingList',
		replace: false,
        scope : {
            actionOpenWi : '&',
            caseReference : '=',
            caseState: '=',
			headerClass: '@',
			header: '@',
            triggerRefresh: '&',
            actionMethod : '&',
            displayFullPane : '=',
            notificationsEnabled: '='
        },
        link: function($scope, ele, attrs) {
            $scope.getContentUrl = function () {
				////console.log ("Template path : " + attrs.templatePath);
                if (typeof attrs.templatePath  == 'undefined') {
                    ////console.log ("Template path undefined => returning default");
                    return '../case-pending-list.html';
                } else {
                    ////console.log ("Template path is defined, returning : " + attrs.templatePath);
                    return attrs.templatePath;
                }
            }
            $scope.contentUrl = $scope.getContentUrl();
			$scope.$watch("caseReference", function(newVal, oldVal){
                if (newVal ) {
                    // get activities for this caseRef
                    $scope.getPendingActivities(newVal);
                    $scope.getAvailableActions(newVal);
                    $scope.getAdhocActivities(newVal);
                }
            });
        },

		template: '<div ng-include="contentUrl"></div>'
    };
}


