/**
 * Created by Jez on 11/4/2016.
 */

angular.module('components.casePieDisplay', [])
    .controller('CasePieDisplayController', ['$scope', "$timeout", function ($scope, $timeout) {
        //console.log("*****************CasePieDisplayDirective Controller");


		vm = this;

		$scope.parseData = function(linkedcases, roleName, donutCategory) {
			//console.log("*&* Called with:" + linkedcases + '' + roleName + '' + donutCategory);
            for(var i = 0; i < linkedcases.length; i++)	{
                if (linkedcases[i].roleName == roleName) {
                    cases = linkedcases[i].caseObjectDetails;
                    $scope.linkedCases = cases;
                    break;
                }
            }

            // parse categories into a more manageable structure
            var parsedcases = [];
            if (cases != null) {
                for(var i = 0; i < cases.length; i++)	{
                    parsedcase = [caseRef = cases[i].caseReference];
                    for(var j = 0; j < cases[i].details.length; j++) {
                        parsedcase[cases[i].details[j].name] = cases[i].details[j].value;
                    }
                    parsedcases.push(parsedcase);
                }
            }
            $scope.parsedcases = parsedcases;

            // sort the cases based on the selected category

            categories = {};
            //var category = "category";
            var category = donutCategory;
            for (var i = 0; i < parsedcases.length; i++) {
                var item = parsedcases[i];
                var valcategory = item[category];
                if (!(valcategory in categories)) {
                    categories[valcategory] = [];
                }
                categories[valcategory].push(item);
            }

            // now create the dataset for the pie chart

            var dataset = [];
            datasetitem = [];

            for(var acat in categories) {
                datasetitem = [
                    acat,
                    categories[acat].length,
                ];
                dataset.push(datasetitem);
            }

            vm.dataset = dataset;
            $scope.dataset = dataset;
            $scope.renderDonut($scope.datasetname, $scope.dataset, $scope.datasetname, $scope.donutDiv);
		}


		$scope.renderDonut = function(datasetname, dataset, title, donutDiv) {

 
		$timeout(function() {

		$(function() {
		var newh = $("#box").height();
    
        $( window ).resize(function() {
			//console.log("*^* redraw");
			newh = $("#box").height();
			donutChart.redraw();
			donutChart.reflow();
		});
		});
		
		donutChart = new Highcharts.Chart({

        credits: {
			enabled: false
		},
		chart: {
            type: 'pie',
			renderTo: donutDiv,
			margin: [20, 20, 20, 20],
			spacing: [0, 0, 0, 0],
			events: {
				click: function (event) {
					$scope.selectedCategory = "";
					$scope.$apply();
				}
			}
        },
        title: {
            text: null
        },
        plotOptions: {
			pie: {
				slicedOffset: 0,
				size:'60%',
				dataLabels: {
					enabled: true
				}
			},
			series: {
                point: {
                    events: {
                        click: function () {
							//console.log("*%* setting selected to: " +this.name);
							$scope.selectedCategory = this.name;
							$scope.$apply();
                        }
                    }
                }
            }
        },
		exporting: {
			buttons: {
				contextButton: {
					enabled: false
				}
			}
		},
        series: [{
            name: datasetname,
            data: dataset
        }],
		});
		}, 1000);
		////console.log("***Done!");
		}


}]);