/**
 * Created by Jez on 6/9/2016.
 */

angular.module('components.favouriteCasesDisplay', [])
    .controller('FavouriteCasesDisplayController', ['$scope', '$rootScope', "CaseDisplayBPMServices", "CaseManagementService", "CaseInformationService", "$location", function ($scope, $rootScope, CaseDisplayBPMServices, CaseManagementService, CaseInformationService, $location) {
		//console.log("*****************favouriteCasesDisplay Controller");

		$scope.ready = false;

		$scope.openCase = function (caseRef) {
			$location.path("/pageCaseDisplay/"+caseRef);
		}

		// get favourite cases
		CaseDisplayBPMServices.readCaseFavourites($rootScope.userResourceDetails.guid).then(
				function (result) {
					$scope.favouriteCases = [];
					var settingProperties = result['settingProperties'];
					if (settingProperties != undefined) {
                        if (settingProperties['@Value'] != undefined) {
                            var favouriteCaseRefs = settingProperties['@Value'].split(',');
                        } else {
                            var favouriteCaseRefs = settingProperties[0]['@Value'].split(',');
                        }
						favouriteCaseRefs = favouriteCaseRefs.reverse();
						angular.forEach(favouriteCaseRefs, function (caseRef) {
							var favouriteCase = {};
							favouriteCase.caseRef = caseRef;

							// extract the case type (short class name) from caseRef
							var caseRefString = favouriteCase.caseRef;
							var seploc = caseRefString.indexOf('-');
							var BDSHeader = caseRefString.slice(0,seploc);
							caseRefString = caseRefString.substring(seploc+1,caseRefString.length);
							var seploc = caseRefString.indexOf('-');
							var MajorVers = caseRefString.slice(0,seploc);
							caseRefString = caseRefString.substring(seploc+1,caseRefString.length);
							seploc = caseRefString.indexOf('-');
							var ClassName = caseRefString.slice(0,seploc);
							caseRefString = caseRefString.substring(seploc+1,caseRefString.length);
							seploc = caseRefString.indexOf('-');
							var shortClassName = ClassName.slice(ClassName.lastIndexOf(".")+1);
							var BDSId = caseRefString.slice(0,seploc);

							favouriteCase.class = ClassName;
							favouriteCase.type = shortClassName;

							$scope.favouriteCases.push(favouriteCase);

							// now get case summary info
							var summary = {};
							summary.caseRef = favouriteCase.caseRef;

							// useDefault: false on callback to getCaseInformation supresses error messages when case has been deleted
							CaseInformationService.getCaseInformation(summary,
									{
										useDefault: false,
										onSuccess: function () {
											// parse the case summary to create a more readable structure and store in favouriteCase object
											favouriteCase.fieldSummary = {};
											angular.forEach(summary.caseRefInformation[0].details, function (caseAttribute) {
												if (caseAttribute.isState) {
													favouriteCase.fieldSummary.STATE = {}
													favouriteCase.fieldSummary.STATE.label = caseAttribute.label;
													favouriteCase.fieldSummary.STATE.value = caseAttribute.value;
													// set friendly state labels
													var statesModel = {};
													statesModel.caseReference = summary.caseRef;
													statesModel.caseRefArray = [];
													statesModel.caseRefArray.push(summary.caseRef);
													CaseManagementService.getCaseStates(statesModel,{
														useDefault: false,
														onSuccess: function()
														{
															favouriteCase.fieldSummary.STATE.valueLabel = statesModel.caseStates[0].value.label;

														},
														onFailure: function(error) {
															// handle if case wasnt there any more
															favouriteCase.fieldSummary.STATE.valueLabel = 'Case Deleted';
														}
													});
												}
												if (caseAttribute.isCaseIdentifier) {
													favouriteCase.fieldSummary.CASEID = {}
													favouriteCase.fieldSummary.CASEID.label = caseAttribute.label;
													favouriteCase.fieldSummary.CASEID.value = caseAttribute.value;
												}
												favouriteCase.fieldSummary[caseAttribute.name] = {}
												favouriteCase.fieldSummary[caseAttribute.name].label = caseAttribute.label;
												favouriteCase.fieldSummary[caseAttribute.name].value = caseAttribute.value;
											});
											favouriteCase.deleted = false;
											$scope.$apply();
											$scope.ready = true;
										},
										onFailure: function(error) {
                                            console.info('Unable to retrieve case information, case has probably been deleted \n' + JSON.stringify(error));
											favouriteCase.deleted = true;
											$scope.$apply();
										}
									});

						});
					}
				}
		)

	}]);