/**
 * Created by JSmith on 3/7/2016.
 */

angular.module('components.genericCommentDisplay', [])
    .controller('GenericCommentDisplayController', ['$scope', "$timeout", "$mdDialog", "$rootScope", function ($scope, $timeout, $mdDialog, $rootScope) {
        //console.log("*****************genericCommentDisplayDirective Controller");
        //console.log("*****************genericCommentDisplayDirective Controller with reference " + $scope.reference);

        // whatever is passed as an reference will be transformed as follows:

        // process the reference to switch any '-' to '.' and any ';' to '.' use this as className
        // add default id and version 1-0
        // add BDS-1 at start

        //eg)DocumentID-000d2ec9-0589-44bf-b8de-ff983fd2ec42-1.0
        //to BDS-1-DocumentID.000d2ec9.0589.44bf.b8de.ff983fd2ec42.1.0-1-0

        // switches - to .

        $scope.showComments = function() {

            var caseClass = $scope.reference.split('-').join('.');
            if (caseClass.indexOf(';') != -1) {
                caseClass = caseClass.split(';').join('.');
            }
            $scope.caseReference = 'BDS-1-' + caseClass + '-1-0';
            $scope.commentModel = {};
            $scope.commentModel.caseReference = $scope.caseReference;
            //console.log("*&* Set caseref for comments to: " + $scope.commentModel);

            $mdDialog.show({
                controller: DocCommentsDialogController,
                templateUrl: 'components/generic-comment-display/generic-comment-display-dialog.html',
                parent: angular.element(document.body),
                clickOutsideToClose: true,
                fullscreen: false,
                locals: {commentModel: $scope.commentModel,description: $scope.description},
            }).then(function () {

            });
        }

}]);

function DocCommentsDialogController($scope, $mdDialog, commentModel, description) {
    $scope.commentModel = commentModel;
    $scope.description = description
    $scope.hide = function() {
        $mdDialog.hide();
    };
    $scope.cancel = function() {
        //console.log("Dialog done");
        $mdDialog.hide();
    };
}

