/**
 * Created by Jez on 14/6/2016.
 */

angular.module('components.sections.homeSection', ['components.recentCasesDisplay.directive', 'components.favouriteCasesDisplay.directive'])
    .controller('HomeSectionController', ['$scope', "$timeout", '$location', 'BPMChartService', function ($scope, $timeout, $location, BPMChartService) {
		//console.log("*****************HomeSection Controller");
		


		//Create a chartModel, could be extended to add group
		createChartModel = function (filter, area, attribute) {
			var model = {
				"dataPayload": {
					"query": {
						"filter": filter,
						"area": area,

						"category": {
							"attribute": attribute,
							"type": "COUNT"
						}
					},
					"options": ""
				}
			};
			return model;
		};


		//Create a config for Pie
		createConfigModelPieLegendRight = function (title) {
			var config = {
				chart: {
					plotBackgroundColor: null,
					plotBorderWidth: null,
					plotShadow: false,
					type: 'pie'
				},
				title: {
					text: title
				},
				tooltip: {
					pointFormat: '{series.name}: <b>{point.y}</b>'
				},
				plotOptions: {
					pie: {
						allowPointSelect: true,
						cursor: 'pointer',
						dataLabels: {
							enabled: false
						},
						showInLegend: true
					}
				},
				credits: {
					enabled: false
				},
				legend: {
					
				},
				series: []
			};

			return config;
		};


		loadPieChartSeries = function (model, config, serieName) {
			BPMChartService.getChart(model, {
				onSuccess: function (result) {
					//THIS CODE IS HANDLING PIE
					var chartData = result.data;

					//console.log(chartData);
					// alert(JSON.stringify(chartData));

					var series = [{
						name: serieName,
						colorByPoint: true,
						data: []
					}];

					var total = 0;
					if (chartData && chartData.data) {

						for (var i = 0; i < chartData.data[0].dataset.value.length; i++) {
							var temp = {
								name: chartData.categories.category[i],
								y: chartData.data[0].dataset.value[i]
							};
							total += temp.y;
							series[0].data.push(temp);
						}
					}
					config.title.text = config.title.text + " : " + total;
					config.series = series;

				},
				onFailure: function (exception) {

					// GetChartFailed:

					//console.log(exception);
				}
			});
		};





		formatDateForQuery = function (mydate){
			//'YYYY-MM-DDThh:mm:ss.SSS'
			var result = "";
			result += mydate.getFullYear() + "-";
			var tmpMonth= mydate.getMonth() + 1;
			if (tmpMonth <10)  {
				result += "0";
			}
			result += tmpMonth + "-";
			if (mydate.getDate() <10)  {
				result += "0";
			}
			result += mydate.getDate();
			return result;
		};

		rangeReplacer = function (match, p1, offset, string) {
			var numberOfDaySla = p1;
			var d = new Date();
			var nowFormatted = formatDateForQuery(d);
			d.setDate(d.getDate() - numberOfDaySla);
			var minDateCreationFormatted = formatDateForQuery(d);

			return "[" + minDateCreationFormatted + ","+ nowFormatted +"]";
		};

		reworkFilter = function (str) {
			var newFilter = str.replace(/TIMEDAYFUNCTION\((\d*)\)/, rangeReplacer);
			return newFilter;
		};



		//TODO all this could be refactored

		/*
		 This is how you get Case State Pie
		 $scope.chartModelCaseByState = createChartModel("(caseClass='Service.Cases.Complaint')", "CASE_OBJECTS", "caseState");

		 $scope.chartPieConfigCaseByState = createConfigModelPieLegendRight("Complaint by state");

		 loadPieChartSeries($scope.chartModelCaseByState, $scope.chartPieConfigCaseByState, "Complaint");*/


		/************************************WORK ITEMS*******************************/

		$scope.chartModelWorkItemByActivity = createChartModel(reworkFilter($scope.homePageConf.graph1.filter),
			$scope.homePageConf.graph1.area, $scope.homePageConf.graph1.attribute );


		$scope.chartPieConfigWorkItemByActivity = createConfigModelPieLegendRight($scope.homePageConf.graph1.title);

		loadPieChartSeries($scope.chartModelWorkItemByActivity, $scope.chartPieConfigWorkItemByActivity, $scope.homePageConf.graph1.sectionText);




		/************************************Case Created today Pie*******************************/

		$scope.chartModelCaseCreatedToday = createChartModel(reworkFilter($scope.homePageConf.graph2.filter),
			$scope.homePageConf.graph2.area, $scope.homePageConf.graph2.attribute);

		$scope.chartPieConfigCaseCreatedToday = createConfigModelPieLegendRight($scope.homePageConf.graph2.title);


		loadPieChartSeries($scope.chartModelCaseCreatedToday, $scope.chartPieConfigCaseCreatedToday, $scope.homePageConf.graph2.sectionText);


		/************************************Case too Old Pie*******************************/

		$scope.chartModelCaseOutOfSLA = createChartModel(reworkFilter($scope.homePageConf.graph3.filter), $scope.homePageConf.graph3.area, $scope.homePageConf.graph3.attribute);

		$scope.chartPieConfigCaseOutOfSLA = createConfigModelPieLegendRight($scope.homePageConf.graph3.title);


		loadPieChartSeries($scope.chartModelCaseOutOfSLA, $scope.chartPieConfigCaseOutOfSLA, $scope.homePageConf.graph3.sectionText);












	}]);