/**
 * Created by NamOs on 9/15/2015.
 */

angular.module('components.linkedCaseDisplay', ['components.donutDisplay.directive', 'camelCaseToHuman', 'components.casePieDisplay.directive'])
    .controller('LinkedCaseDisplayController', ['$scope', '$rootScope', "BPMWorklistService", "BPMBusinessActionsService", "BPMLoginService", "CaseInformationService", "CaseDisplayBPMServices", "$mdDialog", "$timeout", "$location", function ($scope, $rootScope, BPMWorklistService, BPMBusinessActionsService, BPMLoginService, CaseInformationService, CaseDisplayBPMServices, $mdDialog, $timeout, $location) {
        
		
	// Start of controller execution
	var vm = this;

	vm.searchBox = false;
	vm.headerBox = true;
	vm.id = $scope.id;
	vm[$scope.id] = true;

		vm.columnsIgnore = $scope.columnsIgnore;
	
	$scope.category="";

		vm.filterByColumnsIgnore = function(entry) {
			if ($scope.columnsIgnore != undefined) {
				return ($scope.columnsIgnore.indexOf(entry.name) < 0);
			} else {
				return true;
			}
		};
	
	// common functions
	
	function findCountWithAttrValue(array, attr, value) {
		var count = 0;
		for(var i = 0; i < array.length; i += 1) {    
			if(array[i][attr] === value) {
				count++;
			}
		}
	}
	
	$scope.isDate = function(date) {
		var formats = [
			moment.ISO_8601,
			"MM/DD/YYYY  :)  HH*mm*ss"
		];
		return moment(date, formats, true).isValid();
	}


	$scope.renderDonut = function(caseObjects, roleName) {
		
		// find the right data set
		for(var i = 0; i < caseObjects.length; i++)	{
			if (caseObjects[i].roleName == roleName) {
				cases = caseObjects[i].caseObjectDetails;
					break;
			}
		}

		// parse categories into a more manageable structure
		var parsedcases = [];
		if (cases != null) {
			for(var i = 0; i < cases.length; i++)	{
				parsedcase = [caseRef = cases[i].caseReference];
				for(var j = 0; j < cases[i].details.length; j++) {
					parsedcase[cases[i].details[j].name] = cases[i].details[j].value;
				}
				parsedcases.push(parsedcase);
			}
		}
		
		// sort the cases based on the selected category
		
		categories = {};
		//var category = "category";
		var category = $scope.donutCategory;
		for (var i = 0; i < parsedcases.length; i++) {
			var item = parsedcases[i];	
			var valcategory = item[category];
			if (!(valcategory in categories)) {
				categories[valcategory] = [];
			}
			categories[valcategory].push(item);
		}
		
		// now create the dataset for the pie chart
		
		var dataset = [];
		datasetitem = [];
	
		for(var acat in categories) {
			datasetitem = [ 
				acat,
				categories[acat].length,
			];
			dataset.push(datasetitem);
		}
		
		vm.dataset = dataset;
		vm.dataloaded = true;
	}
	
	vm.toggle = function (name) {
		vm[name] = !vm[name];
    }

	$scope.toggleUp = function(name) {
		$scope.toggleView({name: name});
	}

	vm.openCase = function (caseRef) {
		$location.path("/pageCaseDisplay/"+caseRef);
	}
	
	$scope.getLinkedCases = function(caseRef) {
		CaseDisplayBPMServices.getNavigateDetailed(caseRef).then(
			function(result){
				$scope.linkedCaseDetails = result.caseObjectsByRole;
				if ($scope.donutDisplay == 'true') {
					$scope.renderDonut(result.caseObjectsByRole, $scope.linkedCaseClass);
				}
			},
			function(error) {
				window.cap.LOGGER.error("ERR_CUST_CLIENT_CTLR_GET_CASE_NAVIGATE_DETAILS: " + error);
			}
		);
	}
	
	
	}
])
