/**
 * Created by Jez on 14/6/2016.
 */

angular.module('components.sections.tasksSection', ['components.workItemsGrid.directive'])
    .controller('TasksSectionController', ['$scope', "$timeout", "BPMLoginService", "BPMWorklistService", "$rootScope", "$location", "CaseDisplayBPMServices", function ($scope, $timeout, BPMLoginService, BPMWorklistService, $rootScope, $location, CaseDisplayBPMServices) {
		//console.log("*****************TasksSection Controller");

		$scope.ready=false;

		$rootScope.$watch('wiSelection', function(newValue) {
			// get caseRef
			if (newValue != undefined) {
                task = newValue[0];
                taskId = newValue[0].id.id;
                if (typeof taskId == 'string') {
                    // have to call the API to preview the workitem and get any Case Refs
                    CaseDisplayBPMServices.previewWorkItemFromList(taskId, $rootScope.userResourceDetails.guid).then(
                        function (result) {
                            // pull the caseRefs
                            var preview = result.workItemPreview[0].FieldPreview;
                            var refs = [];
                            for (i = 0; i < preview.length; i++) {
                                var curField = preview[i];
                                if (curField.type == "Data Reference") {
                                    var ref = {};
                                    ref.caseRef = curField.simpleSpec.value[0];
                                    ref.title = formatCaseReference(curField.simpleSpec.value[0]);
                                    refs.push(ref);
                                }
                            }
                            task.caseRefs = refs;
                            if (task.caseRefs.length < 1) {
                                // no caseref so just open the task
                                openWorkItem(task);
                            } else {
                                if (task.caseRefs > 1) {
                                    console.warn("The task is related to multiple cases - we will open within the context of the first case reference: " + task.caseRefs[0].title);
                                }
                                $location.path("/pageCaseDisplay/" + task.caseRefs[0].caseRef + "/" + task.id.id);
                            }
                        },
                        function (error) {
                            console.error("ERR_TASKS_SECTION_CTLR_PREVIEW_WORKITEMS: " + error);
                        }
                    )
                }
            }
        });

        // required for work list
		//config the priority, you can not change the text, you can remove but don't change the word, you can change the number
		$rootScope.setPriorityLevel = {
			LOW: [0, 30],
			MEDIUM: [30, 60],
			HIGH: [60, 80],
			CRITICAL: [80, 100]
		};

		//bpm-work-views
		$scope.menuItemSelect = function(item){
			$scope.workViewDetails.name = item.name;
			if (item.name == "WorkList") {
				$scope.workListData.workViewId = null;
				$scope.workListData.viewName = item.name;
			} else {
				$scope.workListData.workViewId = item.workViewID;
				$scope.workListData.viewName = item.name;
			}
		};

		// for new demo data
		$scope.workViewData = {
			"start":"0",
			"pageSize":"10",
			"hideLeftMenu": false,
			"workListViews":[

			]
		};

		$scope.workViewDetails = {};

		var gridOptions = {
			data: []
		};

		$scope.workViewDetails.name = 'WorkList';

		$scope.workItemFormDiv = "workItemFormDiv"

		$scope.workListData = {
			"workItemType": "card",
			"workItems": [],
			"workViewId": "",
			"guid": "",
			"start": "0",
			"pageSize": "100",
			"gridOptions": gridOptions,
			"formDiv": $scope.workItemFormDiv
		};

		// Get GUID of the logged-in user BPMLoginService.getExtendedUserInfo
		BPMLoginService.getExtendedUserInfo({
			onSuccess: function (userInfo) {
				$scope.workListData.guid = userInfo.guid;
				$scope.ready=true;
			}
		});

		// This would only be used to show workitems not related to cases.
        openWorkItem = function(workItem) {
        	if (!$scope.wiShowing) {
				$scope.wiShowing = true;
				var config = {};
				config.id = workItem.id.id;
				config.version = -1;
				config.guid = $rootScope.userResourceDetails.guid;
				config.formDiv = "wiDiv";
				if (BPMWorklistService) {
					BPMWorklistService.openWorkItem(config, {
						onSuccess : function() {}
						,
						onFailure : function() {
							console.error("ERR_TASKS_SECTION_CTLR_OPEN_WORKITEM: " + error);
						},
						onEvent : function(eventName) {
							if (eventName == 'wi.COMPLETE' || eventName == 'wi.CANCEL' || eventName == 'wi.CLOSE') {
								$scope.wiShowing = false;
								$scope.$apply();
							}
						}
					});
				}
            }
		}
	}]);