/**
 * Created by NamOs on 08/09/15.
 */
angular.module('components.workItemsGrid.directive', ['components.workItemsGrid'])
    .directive('workItemsGridDirective', workItemsGridDirective);


function workItemsGridDirective() {
    return {
        //TODO review restrict in all directives, I setup AEC to get all but should be minimized
        restrict: 'AEC',
        controller: 'WorkItemsGridController',
		controllerAs: 'workItemsGrid',
		replace: true,
        scope : {
            tableData: '=',
            tableRowCount: '=',
            viewId: '='
        },
        link: function($scope, ele, attrs) {
            $scope.getContentUrl = function () {
				//console.log ("Template path : " + attrs.templatePath);
                if (typeof attrs.templatePath  == 'undefined') {
                    //console.log ("Template path undefined => returning default");
                    return 'components/work-items-grid/work-items-grid.html';
                } else {
                    //console.log ("Template path is defined, returning : " + attrs.templatePath);
                    return attrs.templatePath;
                }
            }
            $scope.contentUrl = $scope.getContentUrl();
			$scope.$watch("viewId", function(newVal, oldVal){
                //console.log ("******************************************************* WorkItemsGrid Directive with $scope.viewId : " + $scope.viewId );
                //console.log ("******************************************************* WorkItemsGrid Directive with newVal : " + newVal );
                //console.log ("******************************************************* WorkItemsGrid Directive with oldVal : " + oldVal );
                if (newVal > 0) {
                    // If we are displaying a work view then we need to retrieve details and setup the table accordingly
                    $scope.getViewDetails(newVal);
                } else {
                    // We are looking at the users worklist and not a view
                    ////console.log("calling set: " + newVal);
                    $scope.setWorkListColumns();
                }
            });
        },
		template: '<div ng-include="contentUrl"></div>'
    };
}


