CaseManager.service(
    'BPMRolesService',
    function (RoleService) {

        //TODO clean file comments + logs

        var selectedRole;
        var roles;

        // We retrieve the roleModel with all the role settings form the server
        selectRoleInt = function (roleName, callback) {

            var requestRole = new tibco.objectapi.service.request.GetRoleModelRequest(roleName);
            RoleService.getRoleModel(requestRole, {
                onSuccess: function (data) {

                    //console.log("****************************ROLENAME Retrieved " + data);
                    selectedRole = data;
                    callback();

                },
                onFailure: function () {
                    alert("FAILED TO RETRIEVE ROLENAME");
                    //console.log("****************************Get WorkList FAILED : ");
                }
            });

        }

        return {
            // Get the roles for the logged in user, this involves calling Directory Engine and the Roles Engine
            getRolesForUser: function (userResourceDetails, callback) {
                if (userResourceDetails.guid == "tibco-admin") {
                    //When logging with tibco-admin = you have always "super" UI Role
                    selectRoleInt("super", callback);
                } else {

                    // On sucess call the listRoles method to ensure the latest roles are loaded
                    var listTarget = [];

                    //alert(JSON.stringify(userResourceDetails));


                    // Build up a list of the groups to which the user belongs ( could also include Positions but not used in this example )
                    angular.forEach(userResourceDetails.group,
                        function (group) {
                            // List the roles for the supplied targets.  This will get all the roles mapped to the targets ( groups ) supplied
                            listTarget.push(group["guid"]);
                        }
                    );

                    // Build up a list of the positions to which the user belongs
                    angular.forEach(userResourceDetails.position,
                        function (position) {
                            // List the roles for the supplied targets.  This will get all the roles mapped to the targets ( groups ) supplied
                            listTarget.push(position["guid"]);
                        }
                    );

                    if (listTarget.length == 0) {
                        // no position/groups mapped at all so set a dummy value
                        listTarget.push("none");
                    }

                    //alert(listTarget);


                    var requestListRole = new tibco.objectapi.service.request.ListRolesRequest();
                    requestListRole.forceReload = true;
                    requestListRole.targets = listTarget;
                    RoleService.listRoles(requestListRole, {
                        onSuccess: function (data) {
                            // On success, we select the first role that came back as a default
                            //console.log("****************************Possible Roles retrieved : " + data);
                            if (data.length > 0) {
                                roles = data;
                                //console.log("At get Role List : " + JSON.stringify(data));
                                //TODO remove the following one if you want to have multiple Role
                                selectRoleInt(data[0].name, callback);
                            } else {
                                alert("ERROR : no roles is assigned to this user.\n Please Review roles mapping AND/OR user mapping");
                            }

                        },
                        onFailure: function () {
                            alert("FAILED TO RETRIEVE ROLENAME");
                            //console.log("****************************Get WorkList FAILED : ");
                        }
                    });

                }
            },
            // Method to get the components for the selected app ( in the selected role )
            getComponentsForApp: function (appName) {
                if (selectedRole) {
                    return (selectedRole.appConfig[appName].components);
                }
            },
            // Method to get the components for the selected app ( in the selected role )
            getSettingForApp: function (appName, settingName) {
                if (selectedRole) {
                    //alert("selectedRole when looking for App Settings");
                    ////console.log("GetSettingForAPp : " + settingName);
                    //alert("AppConfig : " + JSON.stringify(selectedRole.appConfig[appName]));
                    ////console.log("value : " + selectedRole.appConfig[appName].settings.settingsMap[settingName].value);
                    return (selectedRole.appConfig[appName].settings.settingsMap[settingName].value);
                }
            },
            // Method to get the settings for a component in the selected role
            getSettingForComponent: function (appName, componentName, settingName) {
                if (selectedRole) {
                    var val = selectedRole.appConfig[appName].components[componentName].settings.settingsMap[settingName].value;
                    return (val);
                }
            },
            // Method to get the roles which have been retrieved from the engine
            getRoles: function () {
                if (selectedRole) {
                    return (roles);
                }
            },
            // Method to get the roles which have been retrieved from the engine
            getSelectedRole: function () {
                //alert("GetSelectedRole");
                return selectedRole;
            },
            // Method to select the specified role, after this the Service will return settings for that role
            selectRole: function (roleName) {
                if (selectedRole) {
                    selectRoleInt(roleName);
                }
            },
        }
    });