CaseManager.service(
    'BPMRolesService',
    function ($http) {
        //TODO check the above
        // Sample roles service which uses HTTP / REST to get roles information from the AMX BPM server
        // This could easily be changed to use the ObjectAPI rather than direct REST

        // Setup the base paths for our REST calls
        //TODO replace all this copied and pasted from Sample => remove relative URL => it breaks the
        var bpmUrl = "../../bpm/rest/";
        var apaUrl = "../rest/";
        var selectedRole;
        var roles;

        // Allow the user to select a role, when this happens we retrieve the roleModel with all the role settings form the server
        selectRoleInt = function (roleName) {
            var getRoleModelUrl = apaUrl + "roles/v1/model/";
            getRoleModelUrl = getRoleModelUrl + roleName;

            $http.get(getRoleModelUrl)
                .success(function (data, status) {
                    //console.log("At get selected Role : " + JSON.stringify(data));
                    selectedRole = data;
                }).error(function (data, status, headers, config) {
                    alert(data + status);
                });
        }

        return {
            // Get the roles for the logged in user, this involves calling Directory Engine and the Roles Engine
            getRolesForUser: function (userResourceDetails) {
                if (userResourceDetails.guid == "tibco-admin") {
                    //When logging with tibco-admin = you have always "super" UI Role
                    selectRoleInt("super");
                } else {

                // On sucess call the listRoles method to ensure the latest roles are loaded
                var listRolesUrl = apaUrl + "roles/v1?forceReload=true";

                //alert(JSON.stringify(userResourceDetails));


                // Build up a list of the groups to which the user belongs ( could also include Positions but not used in this example )
                angular.forEach(userResourceDetails.group,
                    function (group) {
                        // List the roles for the supplied targets.  This will get all the roles mapped to the targets ( groups ) supplied
                        listRolesUrl = listRolesUrl + "&target=" + group["guid"];
                    }
                );

                // Build up a list of the positions to which the user belongs
                angular.forEach(userResourceDetails.position,
                    function (position) {
                        // List the roles for the supplied targets.  This will get all the roles mapped to the targets ( groups ) supplied
                        listRolesUrl = listRolesUrl + "&target=" + position["guid"];
                    }
                );

                //alert(listRolesUrl);

                $http.get(listRolesUrl)
                    .success(
                    // On success select the first role that came back as a default
                    // This will trigger the UI to update the components and settings as the selectedRole will change
                    function (data, status) {

                        //alert("List Roles : " + data);

                        if (data.length > 0) {
                            roles = data;
                            //console.log("At get Role List : " + JSON.stringify(data));
                            //selectedRole = data[0];
                            //TODO remove the following one if you want to have multiple Role
                            selectRoleInt(data[0].name);
                        } else {
                            alert("ERROR : no roles is assigned to this user.\n Please Review roles mapping AND/OR user mapping");
                        }

                    }).error(
                    function (data, status, headers, config) {
                        alert(data + status);
                    });
                }
            },
            // Method to get the components for the selected app ( in the selected role )
            getComponentsForApp: function (appName) {
                if (selectedRole) {
                    return (selectedRole.appConfig[appName].components);
                }
            },
            // Method to get the components for the selected app ( in the selected role )
            getSettingForApp: function (appName,settingName) {
                if (selectedRole) {
                    //alert("selectedRole when looking for App Settings");
                    ////console.log("GetSettingForAPp : " + settingName);
                    //alert("AppConfig : " + JSON.stringify(selectedRole.appConfig[appName]));
                    ////console.log("value : " + selectedRole.appConfig[appName].settings.settingsMap[settingName].value);
                    return (selectedRole.appConfig[appName].settings.settingsMap[settingName].value);
                }
            },
            // Method to get the settings for a component in the selected role
            getSettingForComponent: function (appName, componentName, settingName) {
                if (selectedRole) {
                    var val = selectedRole.appConfig[appName].components[componentName].settings.settingsMap[settingName].value;
                    return (val);
                }
            },
            // Method to get the roles which have been retrieved from the engine
            getRoles: function () {
                if (selectedRole) {
                    return (roles);
                }
            },
            // Method to get the roles which have been retrieved from the engine
            getSelectedRole: function () {
                //alert("GetSelectedRole");
                return selectedRole;
            },
            // Method to select the specified role, after this the Service will return settings for that role
            selectRole: function (roleName) {
                if (selectedRole) {
                    selectRoleInt(roleName);
                }
            },
        }
    });