/**
 * Created by JeremyS on 08/09/15.
 */
 
var bpmConfig = angular.module('components.configService', []);
bpmConfig.service('ConfigService', function (RestApiService, $q, $timeout, $http) {

    //Name of the Project (to setup specific project context)
    this.projectName = "serviceRequest";
	this.theme = "metal";

        //List CASEs Page Flow details
    this.allHeaderStartBusinessService = [
		{
            label : "Service.Cases.Customer",
            pfModuleName: "%2FServiceRequest_CaseView%2FProcess%20Packages%2FServiceRequest_Actions.xpdl",

            pfName: "CreateCustomer",
            pfVersion: "1.0"
        }
    ];

    //List CASEs Class Names
    this.allCaseTypeSearch = ['Service.Cases.Complaint','Service.Cases.Customer'];

	// Case View Service Processes
	this.allCaseTypeDetails = {
		"Service.Cases.Complaint" : {
			caseIdField : "id",
			headerPSDetails : {
				psModuleName : "/ServiceRequest_CaseView/Process Packages/ServiceRequest_CaseView.xpdl",
				psName : "ComplaintHeader",
				psVersion : "1.0"
			}
		},
		"Service.Cases.Customer" : {
			caseIdField : "id",
			headerPSDetails : {
				psModuleName : "/ServiceRequest_CaseView/Process Packages/ServiceRequest_CaseView.xpdl",
				psName : "CustomerHeader",
				psVersion : "1.0"
			}
		}
	};
	
    this.microServicePfDetails = {
        Comments: {
            pfModuleName: "/MS-Comment/Process Packages/MS-Comment.xpdl",
            pfName: "ShowCommentsCC",
            pfVersion: "1.0"
        },
        Documents: {
            pfModuleName: "/MS-Document/Process Packages/MS-Document.xpdl",
            pfName: "ShowDocuments",
            pfVersion: "1.0"
        },
        Audits: {
            pfModuleName: "/MS-Comment/Process Packages/MS-Comment.xpdl",

            pfName: "ShowAudits",
            pfVersion: "1.0"
        }
		,
        MyAudits: {
            pfModuleName: "/MS-Comment/Process Packages/MS-Comment.xpdl",

            pfName: "ShowAudits",
            pfVersion: "1.0"
        }
    };

//Following the getters of the ConfigService
    this.getProjectName = function () {
        return this.projectName;
    };

    this.getCaseTypeSearch = function (name) {
        var pfDetailGeneric =  {
            pfModuleName: "/CM_Core/Process Packages/CM_Core-GenericServices.xpdl",
            pfName: "getCaseList",
            pfVersion: "1.0"
        };
        return pfDetailGeneric
    };

    this.getAllCaseTypeSearch = function () {
        return this.allCaseTypeSearch;
    };

    this.getCaseTypeDetails = function (caseType) {
        return this.allCaseTypeDetails[caseType];
    };


    this.getMicroServicePFDetails = function (name) {
        return this.microServicePfDetails[name];
    };

    this.getAllHeaderStartBusinessService = function () {
        return this.allHeaderStartBusinessService;
    };


    this.getProjectContextImageUrl = function () {
        return "images/projectContext/" + this.projectName + "/";
    }


})
;
