/**
 * Created by JSmith on 14/08/16.
 */

var DocsViewApp = angular.module('components.DocsViewAppBPMServices', []);
DocsViewApp.service('DocsViewAppBPMServices', function(RestApiService, $q, $timeout, $http) {

	var getBaseUrl = function() {
		var baseUrl = ((window.location.protocol.lastIndexOf('//') == window.location.protocol.length - 1)
				? window.location.protocol : (window.location.protocol + '//'))
			+ ((window.location.host.lastIndexOf('/') == (window.location.host.length - 1))
				? window.location.host : (window.location.host + '/'));
		return baseUrl;
	};
	var getBPMRestUrl = function() {
		var baseUrl = getBaseUrl() + 'bpm/rest/';
		return baseUrl;
	};
    var getAppsBaseUrl = function() {
        var appsBaseUrl = getBaseUrl() + 'apps/rest/';
        return appsBaseUrl;
    };
	var getHeaders = function() {
		//return {'Authorization': "Basic dGliY28tYWRtaW46c2VjcmV0"};
		return {};
	};
	var isCorsEnabled = function() {
		return true;
	};
	var restServiceConfig = {
		getBaseUrl : getBPMRestUrl,
        getAppsBaseUrl : getAppsBaseUrl,
		headers : getHeaders(),
		isCorsEnabled : isCorsEnabled
	};

	var callback = function(deferred) {
		this.onSuccess = function(result) {
			deferred.resolve(result);
		},
			this.onFailure = function(message) {
				alert("Failed to call BPM API: " + message);
				deferred.reject(eval('(' + '{ message: \"' + message + '\" }' + ')') );
			};
	};

	this.logCaseAudit = function(caseRef, userName, userId, processName, state, messageId, message) {
		////console.log("*&* Called logCaseAudit ", messageId);
		var deferred = $q.defer();
		////console.log("*&* Called start");
		var eventBatch = new tibco.objectapi.ec.base.EventBatch();
		var event1 =  new tibco.objectapi.ec.base.Event();

		event1.eventTimestamp = new Date().toISOString();
		event1.message = message;
		event1.messageId = messageId;
		event1.priority = "LOW";
		event1.severity = "AUDIT";
		event1.correlationId = caseRef;

		// convert caseRefString: eg: BDS-1-com.example.casetests.working_case-248-0 to 248:com.example.casetests.working_case:1:BDS
		var caseRefString = caseRef;
		var seploc = caseRefString.indexOf('-');
		var BDSHeader = caseRefString.slice(0,seploc);
		caseRefString = caseRefString.substring(seploc+1,caseRefString.length);
		var seploc = caseRefString.indexOf('-');
		var MajorVers = caseRefString.slice(0,seploc);
		caseRefString = caseRefString.substring(seploc+1,caseRefString.length);
		seploc = caseRefString.indexOf('-');
		var ClassName = caseRefString.slice(0,seploc);
		caseRefString = caseRefString.substring(seploc+1,caseRefString.length);
		seploc = caseRefString.indexOf('-');
		var BDSId = caseRefString.slice(0,seploc);

		// now we have to reverse the ClassName
		var ClassNameOrg = ClassName;
		var ClassNameRev = ClassName.split('.').reverse().join('.');
		////console.log("*&* Classname: ", ClassNameRev);

		// now create the caseTag
		var caseTag = BDSId + ':' + ClassNameRev + ':' + MajorVers + ':' + BDSHeader;


		var stateAttr = {};
		stateAttr.attributeName = "managedObjectStatus";
		stateAttr.value = state;

		var processNameAttr = {};
		processNameAttr.attributeName = "processName";
		processNameAttr.value = processName;


		var principalNameAttr = {};
		principalNameAttr.attributeName = "principalName";
		principalNameAttr.value = userName;

		var principalIdAttr = {};
		principalIdAttr.attributeName = "principalId";
		principalIdAttr.value = userId;

		var caseSearchTagAttr = {};
		caseSearchTagAttr.attributeName = "caseSearchTag";
		caseSearchTagAttr.value = caseTag;

		var caseMessageCategoryAttr = {};
		caseMessageCategoryAttr.attributeName = "messageCategory";
		caseMessageCategoryAttr.value = "GLOBAL_DATA";

		var managedObjectIdAttr = {};
		managedObjectIdAttr.attributeName = "managedObjectId";
		managedObjectIdAttr.value = caseRef;

		var managedObjectTypeAttr = {};
		managedObjectTypeAttr.attributeName = "managedObjectType";
		managedObjectTypeAttr.value = 'BDS';

		var componentIdAttr = {};
		componentIdAttr.attributeName = "componentId";
		componentIdAttr.value = 'BDS';

		event1.attribute = [stateAttr, processNameAttr, principalNameAttr, principalIdAttr, caseSearchTagAttr, caseMessageCategoryAttr, managedObjectIdAttr, managedObjectTypeAttr, componentIdAttr];

		eventBatch.event = [event1];
		////console.log("*&* Called done");
		var request = new tibco.objectapi.service.request.EventRequest(eventBatch);
		////console.log("created request", JSON.stringify(request));
		RestApiService.setRestServiceConfig(restServiceConfig);
		////console.log("*&* sending logCaseAudit event");
		RestApiService.getAuditService().event(request, new callback(deferred));
		////console.log("*&* sent logCaseAudit event");
		return deferred.promise;
	}

});