/**
 * Created by JSmith on 14/08/16.
 */

var SrcApp = angular.module('components.SrcDisplayServices', []);
SrcApp.service('SrcAppBPMServices', function(RestApiService, $q, $timeout, $http) {

	var getBaseUrl = function() {
		var baseUrl = ((window.location.protocol.lastIndexOf('//') == window.location.protocol.length - 1)
				? window.location.protocol : (window.location.protocol + '//'))
			+ ((window.location.host.lastIndexOf('/') == (window.location.host.length - 1))
				? window.location.host : (window.location.host + '/'));
		return baseUrl;
	};
	var getBPMRestUrl = function() {
		var baseUrl = getBaseUrl() + 'bpm/rest/';
		return baseUrl;
	};
    var getAppsBaseUrl = function() {
        var appsBaseUrl = getBaseUrl() + 'apps/rest/';
        return appsBaseUrl;
    };
	var getHeaders = function() {
		//return {'Authorization': "Basic dGliY28tYWRtaW46c2VjcmV0"};
		return {};
	};
	var isCorsEnabled = function() {
		return true;
	};
	var restServiceConfig = {
		getBaseUrl : getBPMRestUrl,
        getAppsBaseUrl : getAppsBaseUrl,
		headers : getHeaders(),
		isCorsEnabled : isCorsEnabled
	};

	var callback = function(deferred) {
		this.onSuccess = function(result) {
			deferred.resolve(result);
		},
			this.onFailure = function(message) {
				alert("Failed to call BPM API: " + message);
				deferred.reject(eval('(' + '{ message: \"' + message + '\" }' + ')') );
			};
	};

	this.getCaseModel = function(caseClass) {
		//console.log("Called with: ", caseClass);
		var deferred = $q.defer();
		var request = new tibco.objectapi.service.request.GetCaseClassInfoRequest();
		request.includeLabels = true;
		request.includeAttributes = true;
		request.includeGlobalObjectAttributes = true;
		//request.setCaseClasses(['Service.Cases.Complaint']);
		//request.caseclass = {'Service.Cases.Complaint'};
		//request.caseClasses = {caseClass};
		//request.caseClasses = [caseClass];
		RestApiService.setRestServiceConfig(restServiceConfig);
		RestApiService.getGlobaldataAdminService().getCaseClassInfo(request, new callback(deferred));
		return deferred.promise;
	};

	this.findCaseRefByCriteria = function(caseType, version, params, availableParams, searchOptions, startPosition) {
		//console.log("*&* Called findCaseRefByCriteria ", caseType, version, params, searchOptions, startPosition);
		var deferred = $q.defer();
		////console.log("*&* Called start");
		
		var caseCriteria = new tibco.objectapi.bds.CaseCriteriaType();
		
		
		var queryString = "";
		var queryStringAny = "";
		var rawQuery = "";
		
		for(var param in params){
			//console.log("Checking param: ", params[param]);
			//console.log("Checking param name is: ", param);
			if (param === "QUERY_ALL") {
				// This should query any text field
				for(var i = 0; i < availableParams.length; i++) {
					//console.log("Checking got attrib: ", JSON.stringify(availableParams[i]));
					if (availableParams[i].type === 'ATTR_TEXT') {
						//console.log("Checking got a text attr: ", availableParams[i].key);
						if (queryStringAny === "") {
							queryStringAny = "UPPER(" + availableParams[i].key + ") = '*" + params[param].toUpperCase() + "*'";
						} else {
							queryStringAny = queryStringAny + " OR " + "UPPER(" + availableParams[i].key + ") =" + "'*" + params[param].toUpperCase() + "*'";
						}
					}
				}
			} else if (param != "query") {
				//console.log("*&* doing a normal param: ", param);
				//console.log("*&* params[param] is: ", params);
				if (params[param] != undefined) {
					if (queryString === "") {
						//console.log("*&* empty querystring");
						if (isNaN(params[param])) {
							var isText = false;
							for(var i = 0; i < availableParams.length; i++) {
								if ((availableParams[i].key == param) && (availableParams[i].type == 'ATTR_TEXT')) {
									queryString = "UPPER(" + param + ") = '" + params[param].toUpperCase() + "'";
									isText = true;
									break;
								}
							}
							if (!isText) {
								queryString = param + " = '" + params[param].toUpperCase() + "'";
							}
						} else {
							queryString = param + " = '" + params[param] + "'";
						}
					} else {
						if (isNaN(params[param])) {
							queryString = queryString + " AND UPPER(" + param + ") = '" + params[param].toUpperCase() + "'";
						} else {
							queryString = queryString + " AND " + param + " = '" + params[param] + "'";
						}
					}
				}
			} else if (param === "query") {
				// handle a text query string
				rawQuery = params[param];
			}

		}

		// handle a text query string
		if (rawQuery != "") {
			if (queryString === "") {
				queryString = rawQuery;
			} else {
				queryString = queryString + " AND (" + rawQuery + ")";
			}
		}

		// Handle adding the "ANY" or text query to the queryString
		if (queryStringAny != "") {
			if (queryString === "") {
				queryString = queryStringAny;
			} else {
			queryString = queryString + " AND (" + queryStringAny + ")";
			}
		}

		// Add the orderBy
		var order = 'DESC';
		if (searchOptions.ascending == true) {
			order = 'ASC';
		}

		if (queryString != '') {
			queryString = queryString + " ORDER BY " + searchOptions.orderBy + " " + order;
		} else if (searchOptions.orderBy != undefined) {
			queryString = "ORDER BY " + searchOptions.orderBy + " " + order;
		}
		

		//console.log("*&* querystring is: ", queryString);
		
		caseCriteria.queryString = queryString;
		//caseCriteria.queryString = "category = 'PRODUCT'";
		var param = new tibco.objectapi.bds.NamedParameterAssignment();
		param.name = "category";
		param.value = "PRODUCT";
		var namedParameterAssignment = [];
		namedParameterAssignment.push(param);
		
		//caseCriteria.namedParameterAssignment = namedParameterAssignment;
		
		var paginationOptions = new tibco.objectapi.bds.PaginationOptions();
		paginationOptions.maxResults = searchOptions.maxResults;
		paginationOptions.startPosition = startPosition;
		caseCriteria.paginationOptions = paginationOptions;
		
		
		var request = new tibco.objectapi.service.request.FindCaseByCriteriaRequest(caseCriteria, caseType, version.toString());
		//console.log("created request", JSON.stringify(request));
		
		RestApiService.setRestServiceConfig(restServiceConfig);
		//console.log("*&* sending findCaseByCriteria");
		RestApiService.getGlobaldataService().findCaseByCriteria(request, new callback(deferred));
		//console.log("*&* sent findCaseByCriteria", request);
		return deferred.promise;	
		
	}

	//tibco.objectapi.service.RestService

});