(function(win, doc) {
    var addStyleToHead = function(styleString, specifiedId) {
        var head = doc.head || doc.getElementsByTagName('head')[0];

        var style = doc.createElement('style');
        style.type = 'text/css';

        if (specifiedId) {

            var oldStyle = doc.getElementById(specifiedId);
            if (oldStyle) {
                head.removeChild(oldStyle);
            }

            style.id = specifiedId;
        }

        if (style.styleSheet) {
            style.styleSheet.cssText = styleString;
        } else {
            style.appendChild(doc.createTextNode(styleString));
        }

        head.appendChild(style);
    }; 

    var setActionHeightProperly = function(actionHeight) {
        var bottomTriangleHeight = 30, searchBarHeight = 40;

        addStyleToHead('.bpm-business-actions-container.push-down {height:' + actionHeight + 'px;}');
        addStyleToHead('.bpm-business-actions-container md-content {height:' + (actionHeight - bottomTriangleHeight - searchBarHeight) + 'px;}');
    };

    win.BpmBusinessActionsAdjustor = {
        _dropDownButtonHeight: 44,
        _adjustTheExpectedHeight: function(heightExpected) {
            doc.body.addEventListener('click', function(event) {
                var target = event.target || event.srcElement;

                if (target.parentNode && target.parentNode.className.indexOf('drop-down-container') > -1) {
                    setTimeout(function() {
                        setActionHeightProperly(heightExpected);
                    }, 100);
                }
            }, false);
        },
        giveBusinessActionsHeightSpace: function(heightSpace) {
            this._adjustTheExpectedHeight(heightSpace - this._dropDownButtonHeight);
        },
        makeBusinessActionsFullScreen: function() {
            this._adjustTheExpectedHeight(win.innerHeight - this._dropDownButtonHeight);
        },
        changeBackgroundColorOfRefreshBar: function(colorExpected) {
            var refreshBarStyle = '.bpm-business-actions-container .action-refresh-bar {height: 30px;line-height: 30px;padding-top: 3px;margin-top: 0;background-color:' + colorExpected + '}';
            addStyleToHead(refreshBarStyle);
        }
    };

})(window, document);